unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, IdBaseComponent, IdCoder, IdCoder3to4,
  IdCoderUUE, JPEG, IdCoderMIME, JvComponent, JvDragDrop, clipbrd;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Image1: TImage;
    Image2: TImage;
    Edit2: TEdit;
    Button2: TButton;
    Button3: TButton;
    JvDragDrop1: TJvDragDrop;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
      Value: TStringList);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  with TOpenDialog.Create(Self) do
    try
      if Execute then
      begin
        Edit1.Text := FileName;
        image1.Picture.LoadFromFile(FileName);
      end;
    finally
      Free;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  stream: TFileStream;
begin
  stream := TFileStream.Create(Edit1.Text, fmOpenRead);
  stream.Seek(0, soFromBeginning);
  with TIdEncoderMIME.Create(nil) do
    try
      Edit2.Text := Encode(stream, stream.size);
    finally
      Free;
    end;
  stream.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  stream: TFileStream;
begin
  stream := TFileStream.Create('t:\stream.bmp', fmCreate);
  stream.Seek(0, soFromBeginning);
  with TIdDecoderMIME.Create(nil) do
    try
      DecodeToStream(Edit2.Text, stream);
      stream.Free;
      Image2.Picture.LoadFromFile('t:\stream.bmp');
    finally
      Free;
    end;
end;

procedure TForm1.JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
  Value: TStringList);
var
  stream: TFileStream;
begin
  stream := TFileStream.Create(Value.Strings[0], fmOpenRead);
  stream.Seek(0, soFromBeginning);
  with TIdEncoderMIME.Create(nil) do
    try
      Clipboard.AsText := Encode(stream, stream.size);
    finally
      Free;
    end;
  stream.Free;

end;

end.
